
var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "led-wizard.log";
lWarn = new Logger(LOGFILE_NAME);
//lInfo = new Logger(LOGFILE_NAME);


function storeSubParameter(path, value) {
    try 
    {
        lInfo.logln("StoreSubParameter Path " + path  + " value " + value + " type " + typeof(value));
        Property.setProperty(path, value);
        Property.setFlag(path, 'ARCHIVE', true);
    }
    catch (e)
    {
        lWarn.logln("Fehler beim StoreSubParameter " + e + " Path " + path  + " value " + value);
    }        
}

var sErrorMSG="";
function setWithRetryOneValue(deviceObj,value,bank,index,iRetry, fFehlertolerant) {
    var checkValue=-1;
	try {
		deviceObj.setConfig(bank,index,value);
		checkValue=deviceObj.getConfig(bank,index);
	} 
	catch (e) {
		lWarn.logln("Fehler beim Schreiben : B" + bank + " I" + index + " R:" + iRetry + " Val:" + value); 
	}
    if (fFehlertolerant==null)
        fFehlertolerant=false;
    if (!fFehlertolerant) {
        if (checkValue!=value) {
            if (iRetry>0) {
                lInfo.logln('Fehler: Wert B:'+bank+' ind:'+index+' geschrieben: ' + value + ' gelesen: ' + checkValue + ' noch ' + iRetry + ' Versuche');
                return setWithRetryOneValue(deviceObj,value,bank,index,iRetry-1);
            } else {
                sErrorMSG+='Letzer Versuch: Wert B:'+bank+' ind:'+index+' geschrieben: ' + value + ' gelesen: ' + checkValue ;
                lInfo.logln(sErrorMSG );
                return false;
            }
        } else {
            lInfo.logln('OK : Wert B:'+bank+' ind:'+index+' geschrieben: ' + value + ' gelesen: ' + checkValue);
            return true;
        }
    }
    lInfo.logln('(vielleicht) OK : Wert B:'+bank+' ind:'+index+' geschrieben: ' + value + ' gelesen: ' + checkValue);
    return true;
}

function prepareStep(step,currentDevice, maxNrOfDevices) {
    try {
        var action = Property.getNode('temp/' + currentDevice + '/action').getValue();
        lInfo.logln('prepareStep called with step: ' + step + ' currentDevice: ' + currentDevice + ' maxNrOfDevices: ' + maxNrOfDevices + ' action: ' + action);
        switch (action) {
            case 'delete': {            
                new Event('led-wizard.answer',{type:'step',detail:'complete',error:false,currentDevice:currentDevice,maxNrOfDevices: maxNrOfDevices}).raise();
                new Event('led-wizard.step',{detail:'complete',error:false,currentDevice:currentDevice,maxNrOfDevices: maxNrOfDevices}).raise();              
            }
            break;
            case 'errorParamList': {
                new Event('led-wizard.answer',{type:'step',detail:'complete',error:true,currentDevice:currentDevice,maxNrOfDevices: maxNrOfDevices}).raise();
                new Event('led-wizard.step',{detail:'complete',error:true, currentDevice:currentDevice,maxNrOfDevices: maxNrOfDevices}).raise();                          
            }
            break;
            case 'programm': {
                new Event('led-wizard.answer',{type:'step',detail:'step',index:step,currentDevice:currentDevice,maxNrOfDevices: maxNrOfDevices}).raise();
                new Event('led-wizard.step',{detail:'step',index:step,currentDevice:currentDevice,maxNrOfDevices: maxNrOfDevices}).raise();                           
            }
            break;
            default: {
                new Event('led-wizard.answer',{type:'step',detail:'complete',error:true,currentDevice:currentDevice,maxNrOfDevices: maxNrOfDevices}).raise();
                new Event('led-wizard.step',{detail:'complete',error:true, currentDevice:currentDevice,maxNrOfDevices: maxNrOfDevices}).raise();                                      
            }
        }
    } catch (e) {
        lWarn.logln('Exception in prepareStep: ' + e);
    }
}
    
function makeStep(deviceIndex, maxNrOfDevices){
    try {
    	var dsuid=Property.getNode('temp/' + deviceIndex + '/dsuid').getValue();
    	var array=Property.getNode('temp/' + deviceIndex + '/value').getValue();
    	var step=Property.getNode('temp/' + deviceIndex + '/step').getValue();
    	lInfo.logln("step " + step  + " for  " + dsuid);
    	array = array.replace(/&amp;/g, '&').replace(/&quot;/g, '"').replace(/&lt;/g, '<').replace(/&gt;/g, '>').replace(/&#039;/g, '\'');
    	var oArray=JSON.parse(array);
    	 
    	var oDevice=getDevices().byDSUID(dsuid);
        if (oDevice==null) {
            sErrorMSG='Gert ' + dsuid + ' nicht gefunden';
            lWarn.logln(sErrorMSG);
            new Event('led-wizard.step',{detail:'complete',error:true, currentDevice:deviceIndex, maxNrOfDevices: maxNrOfDevices}).raise();
            new Event('led-wizard.answer',{detail:'complete',type:'step',error:true, currentDevice:deviceIndex, maxNrOfDevices: maxNrOfDevices}).raise();
            return;
        }
    	if (step+1 < oArray.length)
    	{
            setWithRetryOneValue(oDevice,oArray[step].value,oArray[step].bank,oArray[step].offset,3);
            Property.setProperty('temp/' + deviceIndex + '/step', step+1);
            lInfo.logln('OK schicke step ' + (step+1));
            new Event('led-wizard.step',{detail:'step','index':step+1, 'currentDevice':deviceIndex,'maxNrOfDevices': maxNrOfDevices}).raise();    
            new Event('led-wizard.answer',{detail:'step',type:'step','index':step+1,'currentDevice':deviceIndex,'maxNrOfDevices': maxNrOfDevices}).raise();  
    
    	} else {
    	    //last step
            setWithRetryOneValue(oDevice,oArray[step].value,oArray[step].bank,oArray[step].offset,3);
            lInfo.logln('Ende erreicht, schicke complete');
            new Event('led-wizard.step',{detail:'complete',error:false,currentDevice:deviceIndex,maxNrOfDevices: maxNrOfDevices}).raise();
            new Event('led-wizard.answer',{detail:'complete',type:'step',error:false,currentDevice:deviceIndex,maxNrOfDevices: maxNrOfDevices}).raise();
    	}
    } catch (e) {
        lWarn.logln('Exception in makeStep: ' + e);
    }
}

function makeComplete(deviceIndex, maxNrOfDevices){
    try {
    	lInfo.logln('ende device nr ' + deviceIndex + ' of ' + maxNrOfDevices + ', bereinige Daten ');
        
    	var dsuid=Property.getNode('temp/' + deviceIndex + '/dsuid').getValue();
    	var id=Property.getNode('temp/' + deviceIndex + '/catalogeID').getValue();
    	
    	if (id==-1) {
    		Property.getNode('devices').removeChild(dsuid);
    	} else {
    		storeSubParameter('devices/' + dsuid + '/dsuid' , dsuid);
        	storeSubParameter('devices/' + dsuid + '/catalogeID' , id);
        	storeSubParameter('devices/' + dsuid + '/ts' , ""+(new Date()).getTime());	
    	}
    	
    
        Property.store();
        var nextIndex = parseInt(deviceIndex, 10) + 1;
        if (nextIndex < maxNrOfDevices) {
            var count= Property.getNode('temp/' + nextIndex +'/count').getValue();
            new Event('led-wizard.answer',{type:'step',detail:'prepare',count:count,currentDevice:nextIndex,maxNrOfDevices: maxNrOfDevices}).raise();
            new Event('led-wizard.step',{detail:'prepare',count:count,currentDevice:nextIndex,maxNrOfDevices: maxNrOfDevices}).raise();                           
        } else {
            Property.getNode('/scripts/led-wizard').removeChild('temp');
        }
    } catch (e) {
        lWarn.logln('Exception in makeComplete: ' + e);
    }
}

if (raisedEvent.parameter.detail != null) {
	if (raisedEvent.parameter.detail == 'step') {		
		makeStep(raisedEvent.parameter.currentDevice, raisedEvent.parameter.maxNrOfDevices);
    }
	if (raisedEvent.parameter.detail == 'complete') {		
	    makeComplete(raisedEvent.parameter.currentDevice, raisedEvent.parameter.maxNrOfDevices);
    }
	if (raisedEvent.parameter.detail == 'prepare') {
	    lInfo.logln('Prepare event: count: ' + raisedEvent.parameter.count + ' currentDevice: ' + raisedEvent.parameter.currentDevice + ' maxNrOfDevices: '  + raisedEvent.parameter.maxNrOfDevices);
	    Property.setProperty('temp/' + raisedEvent.parameter.currentDevice + '/step', 0);
	    prepareStep(0, raisedEvent.parameter.currentDevice, raisedEvent.parameter.maxNrOfDevices);
	}
}

	