var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "led-wizard.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);

function getFeed() {
	var sString=Property.getNode('/system/version/distroVersion').getValue();
	if (sString.indexOf('devel')>=0)
		return 0;
	if (sString.indexOf('test')>=0)
		return 1;
	if (sString.indexOf('beta')>=0)
		return 2;
	if (sString.indexOf('alpha')>=0)
		return 2;
	
	return 3;
}


function storeSubParameter(path, value) {
    try 
    {
        lInfo.logln("StoreSubParameter Path " + path  + " value " + value + " type " + typeof(value));
        Property.setProperty(path, value);
        Property.setFlag(path, 'ARCHIVE', true);
    }
    catch (e)
    {
        lWarn.logln("Fehler beim StoreSubParameter " + e + " Path " + path  + " value " + value);
    }        
}

function fetchDataForManufacture(supplierID) {
	Property.load();
    var h = new HTTP( { 'debug' : 0 }, {});
    lInfo.logln("http://illuminant-wizard.aizo.net/staticDB.php?illuminantMeta=" + supplierID + "&feed=" + getFeed());
    var code = h.get("http://illuminant-wizard.aizo.net/staticDB.php?illuminantMeta=" + supplierID + "&feed=" + getFeed());
    if (Property.getNode('myData')!=null) {
	    var oOldArray=Property.getNode('myData').getChildren();
	    for (var iIndex=0;iIndex<oOldArray.length;iIndex++) {
	    	Property.getNode('myData').removeChild(oOldArray[iIndex].getName());
	    }
    }
    if (code.status.valueOf() === 200) {
    	var DataObject=JSON.parse(code.body);
    	var oIlluIDSaved=[];
    	for (var iIndex=0;iIndex<DataObject.length;iIndex++) {
    		try {
				var illuID=DataObject[iIndex].id;
				storeSubParameter('myData/illuminant' + illuID + '/id',illuID);
				storeSubParameter('myData/illuminant' + illuID + '/data',JSON.stringify(DataObject[iIndex]));
				var codeSub = h.get("http://illuminant-wizard.aizo.net/staticDB.php?illuminant=" + illuID + "&feed=" + getFeed());
			    if (codeSub.status.valueOf() === 200) {
		    		var oDBObject=JSON.parse(codeSub.body);
		        	storeSubParameter('myData/illuminant' + illuID + '/curves',codeSub.body);
			    }
			    oIlluIDSaved.push(illuID);
    		} 
    		catch (e) {
    	        lWarn.logln("Error during resyncing cache");
    	        for (var i in e) {
    	            lWarn.logln(i + ': ' + e[i]);
    	        }
    		}
    	}
	    Property.store();
	
    	Property.setProperty('/scripts/led-wizard/subscriptions/' + supplierID,true);
    	new Event('led-wizard.data-static',{actions:'check','supplierID':supplierID,'illuminants':JSON.stringify(oIlluIDSaved)}).raise();
    }	
}

function prepareSubscription (id) {
	if (Property.getProperty('subscriptions/' + id)==null) {
		var oSubscripion=new Subscription('led-wizard.data-segmented','javascript',
				{'filename1':'/usr/share/dss/data/scripts/http.js',
			     'filename2':'/usr/share/dss/add-ons/led-wizard/fetchSegmentedData.js','script_id':'led-wizard.manufacture-' + id});
		oSubscripion.subscribe();
		
		var oSubscripion=new Subscription('led-wizard.query-'+ id,'javascript',
				{'filename1':'/usr/share/dss/data/scripts/http.js',
			     'filename2':'/usr/share/dss/add-ons/led-wizard/query.js','script_id':'led-wizard.manufacture-' + id});
		oSubscripion.subscribe();
		
		Property.setProperty('subscriptions/' + id,false);
	}
}

function fetchStaticData() {
    var db_data;
    var db_update;
    
    try {
        var h = new HTTP( { 'debug' : 0 }, {});
        lInfo.logln("http://illuminant-wizard.aizo.net/staticDB.php?feed=" + getFeed());
        var code = h.get("http://illuminant-wizard.aizo.net/staticDB.php?feed=" + getFeed(), 'staticDB.php?feed=' + getFeed());
        if (code.status.valueOf() === 200) {
            //lInfo.logln('OK [' + code.status + ']' + code.body);           
            var oAnswer=JSON.parse(code.body);
            var fFound=false;
            for (var iIndex=0;iIndex<oAnswer.manufacture.length;iIndex++) {
            	if (oAnswer.manufacture[iIndex].id==-1)
            		fFound=true;
            }
            if (!fFound)
            	oAnswer.manufacture.push({id:-1,name:'Standard',url:'www.aizo.com'});
            oAnswer.mountingForm.push({id:-1,name:'-'});
            oAnswer.socket.push({id:-1,name:'-'});
            oAnswer.abilityDetail.push({id:"-1",name:"-"});
            
            storeSubParameter("db/manufacture",JSON.stringify(oAnswer.manufacture));
            storeSubParameter("db/mountingForm",JSON.stringify(oAnswer.mountingForm));
            storeSubParameter("db/socket",JSON.stringify(oAnswer.socket));
            storeSubParameter("db/abilityDetail",JSON.stringify(oAnswer.abilityDetail));
          
            Property.store();
            for(var iIndex=0;iIndex<oAnswer.manufacture.length;iIndex++)
            	prepareSubscription(oAnswer.manufacture[iIndex].id);
            new Event('led-wizard.data-segmented',{}).raise();
        } else {
            lWarn.logln(sString + ': FAILED! Server replied: "' + code.status + '"');
            lInfo.logln(code.body);
        }
    } catch (e) {
        lWarn.logln("Error during resyncing cache");
        for (var i in e) {
            lWarn.logln(i + ': ' + e[i]);
        }
    }

}

if (raisedEvent.name=='led-wizard.data-static') {
	Property.load();
	if (raisedEvent.parameter.actions!=null) {
		if (raisedEvent.parameter.actions=='check') {
			var oArray=Property.getNode('subscriptions').getChildren();
			var fReady=Property.getProperty('shouldMessage');
			
			Property.setProperty('references/' + raisedEvent.parameter.supplierID,raisedEvent.parameter.illuminants);
			for (var iIndex=0;iIndex<oArray.length;iIndex++) {
				if (oArray[iIndex].getValue()==false)
					fReady=false;
			}
			if (fReady) {
				Property.setProperty('shouldMessage',false);
				lInfo.logln('DB READY!!!!');
				storeSubParameter("dbrefresh",""+(new Date()).getTime());
				new Event('led-wizard.answer',{result:true,error:'',type:'saveDB'}).raise();
				
				if (Property.getNode('shouldProgramm')!=null) {
	            	lInfo.logln('start Programming after loading the DB');
	            	var dsuid=Property.getProperty('shouldProgramm/dsuid');
	            	var curve_id=Property.getProperty('shouldProgramm/curve_id');           	
	            	
	            	new Event('led-wizard.prog',{actions:'programmCurve','dsuid':dsuid,'curve_id':curve_id,retry:1}).raise();					
	            	Property.getNode('shouldProgramm').getParent().removeChild('shouldProgramm');
				}
				Property.store();
			}
		}
	} else {
		lInfo.logln('start fetching new data segmented way');
		Property.setProperty('shouldMessage',true);
		fetchStaticData();
	}
} else {	
	Property.setProperty("manufacture", "?");
	var pProperty=Property.getNode('manufacture').getPath();	
	lInfo.logln('test: ' + pProperty.substr(32,pProperty.indexOf("/manu")-32));
	Property.setProperty("manufacture", pProperty.substr(32,pProperty.indexOf("/manu")-32));
	fetchDataForManufacture(pProperty.substr(32,pProperty.indexOf("/manu")-32));
}