

var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "led-wizard.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);

function Debug(o){
	lInfo.logln(o);
}


function storeSubParameter(path, value) {
    try 
    {
        lInfo.logln("StoreSubParameter Path " + path  + " value " + value + " type " + typeof(value));
        Property.setProperty(path, value);
        Property.setFlag(path, 'ARCHIVE', true);
    }
    catch (e)
    {
        lWarn.logln("Fehler beim StoreSubParameter " + e + " Path " + path  + " value " + value);
    }        
}


function prepareCurve(oDevice,curve_id,dimmMin,dimmType,fLZ) {
	var deviceProductID=oDevice.productID;
	var deviceFirmwareID=oDevice.revisionID;
	
	if (curve_id.length!=null)
		if (curve_id<0) {
			return doCalcCurve(Math.abs(curve_id),[], 0, deviceProductID, deviceFirmwareID,false, 0);
		}

	var oCatalog=JSON.parse(curve_id);
	var dimmbar_ab=-1;
	var curve=[];
	var AnAb=0;

	for (var kIndex=0;kIndex<oCatalog.length;kIndex++) {
		curve.push({pos:oCatalog[kIndex].pos, value:oCatalog[kIndex].val});
	}
	curve.sort(function(a,b){return a.pos-b.pos;});

	lInfo.logln('calc Curfe with mindim ' + dimmMin + ' and values  ' + JSON.stringify(curve));
	if (dimmMin==-1) {
		return false;
	} else {		 
		if (AnAb>1)
			return doCalcCurve(1, curve, parseInt(''+dimmMin,10), deviceProductID, deviceFirmwareID,fLZ, parseInt(''+dimmType,10)&0x1);
		else
			return doCalcCurve(0, curve, parseInt(''+dimmMin,10), deviceProductID, deviceFirmwareID,fLZ, parseInt(''+dimmType,10)&0x1);		
	}
}

function executeProgramm(dsuid,id,dimmMin,dimmType) {
    var iIndex;
    var oParameterList;
    if (dsuid.length > 1) {
        lInfo.logln('starteProgrammierung f�r mehrere devices');
        for (iIndex = 0; iIndex < dsuid.length; iIndex++) {
            lInfo.logln('Device ' + dsuid[iIndex]);
        }
    }
	lInfo.logln('starteProgrammierung f�r ' + dsuid[0] + ' mit ' +id);
	 try {    
	    Property.setProperty('temp/maxNrOfDevices', dsuid.length);
	    for (iIndex = 0; iIndex < dsuid.length; iIndex++) {
	        var oDevice=getDevices().byDSID(dsuid[iIndex]); //throws exception if device with dsuid not found    	        
    	    if (oDevice.getPropertyNode().getChild('present').getValue()==false) {
    	        var sErrorMSG='Ger�t ' + dsuid[iIndex] + ' aktuell nicht verf�gbar';
    	        lWarn.logln(sErrorMSG);
                //set the needed temp property to delete the device in the complete step 
                Property.setProperty('temp/' + iIndex + '/catalogeID', id);
                Property.setProperty('temp/' + iIndex + '/dsuid', dsuid[iIndex]);
                Property.setProperty('temp/' + iIndex + '/action', 'delete');
                Property.setProperty('temp/' + iIndex + '/count', 0);
    	    } else {    	    
        	    //turn off the device before programming start
        	    new Event('led-wizard.demo',{actions:'setValue',dsuid:dsuid[iIndex],value:0}).raise();
        	    
        		lInfo.logln('prepareCurfe ' + dsuid[iIndex] + ' mit ' +id);
        		
        		oParameterList = prepareCurve(oDevice,id,dimmMin,dimmType,false);
        		lInfo.logln('habe liste ' + oParameterList);		
        		
        		if (oParameterList != false) {
                    Property.setProperty('temp/' + iIndex + '/value', JSON.stringify(oParameterList));
                    Property.setProperty('temp/' + iIndex + '/step', 0);
                    Property.setProperty('temp/' + iIndex + '/catalogeID', id);
                    Property.setProperty('temp/' + iIndex + '/dsuid', dsuid[iIndex]);
                    Property.setProperty('temp/' + iIndex + '/action', 'programm');
                    Property.setProperty('temp/' + iIndex + '/count', oParameterList.length);
        		} else {
                    lWarn.logln('Fehler!: Keine Parameterliste vorhanden');
                    Property.setProperty('temp/' + iIndex + '/action', 'errorParamList');
                    Property.setProperty('temp/' + iIndex + '/count', 0);
        		}
    	    }
        }
	    //start with first device
	    Property.setProperty('temp/deviceIndex', 0);
	    var count= Property.getNode('temp/0/count').getValue();
        new Event('led-wizard.answer',{type:'step',detail:'prepare',count:count,currentDevice:0,maxNrOfDevices: dsuid.length}).raise();
        new Event('led-wizard.step',{detail:'prepare',count:count,currentDevice:0,maxNrOfDevices: dsuid.length}).raise();                           
	 } 
	 catch (e) {
		 lWarn.logln('Exception in led-wizard-prog.executeProgramm()'  + e);
		 new Event('led-wizard.step',{detail:'complete',error:true}).raise();
		 new Event('led-wizard.answer',{type:'step',detail:'complete',error:true}).raise();
	 }
}

/**
 * Removes the device with the given dsuid from the property tree without reseting the dimming curve.
 * This function is used if a device was deleted from the dSS. 
 * @param dsuid [in] dsuid of the device to be removed
 */
function deleteDevice(dsuid) {
    lInfo.logln('starte delete device f�r ' + dsuid);
    //set the temp property for the complete step 
    Property.setProperty('temp/catalogeID', -1);
    Property.setProperty('temp/dsuid', dsuid);
    new Event('led-wizard.step',{detail:'complete',error:false}).raise();
    new Event('led-wizard.answer',{detail:'complete',type:'step',error:false}).raise();
}

function getSupplierID(curve_id) {
	var node=Property.getNode('references');
	if (node==null)
		return null;
	var oArray=node.getChildren();
	for (var iIndex=0;iIndex<oArray.length;iIndex++) {
		var iReferenceArray=JSON.parse(oArray[iIndex].getValue());
		for (var jIndex=0;jIndex<iReferenceArray.length;jIndex++)
			if (""+curve_id==""+iReferenceArray[jIndex])
				return oArray[iIndex].getName();	
	} 
	return null;
}

if (raisedEvent.parameter.actions != null) {
    lInfo.logln("Event " +  raisedEvent.parameter.actions + " will be processed");
    Property.load();
    if (raisedEvent.parameter.actions == 'massProgrammCurve') {
    	try {
    		var oArray=JSON.parse(raisedEvent.parameter.values);
    		var lIndex=0;
    		if (Property.getNode('massProg')!=null)
    			if (Property.getNode('massProg').getChildren()!=null) {
    				var oPropNode=Property.getNode('massProg').getChildren();
    				for (var iIndex=0;iIndex<oPropNode.length;iIndex++) {
    					var oNode=oPropNode[iIndex];
    					var iName=parseInt(oNode.getName(),10);
    					if (iName<=lIndex)
    						lIndex=iName+1;
    				}
    			}
    		for (var iIndex=0;iIndex<oArray.length;iIndex++) {
    			storeSubParameter('massProg/'+ lIndex + '/dsuid',oArray[iIndex].dsuid);
    			storeSubParameter('massProg/'+ lIndex + '/curve_id',oArray[iIndex].curve_id);
    			storeSubParameter('massProg/'+ lIndex + '/state',0);
    			lIndex+=1;
    		}
    		Property.store();
    	} 
    	catch(e) {
   		 lWarn.logln('Exception in led-wizard-prog.massProgrammCurve'  + e);    		
    	}
    }
	if (raisedEvent.parameter.actions == 'programmCurve') {
	    try {
            if (Property.getNode('/scripts/led-wizard/temp') != null) {
                lInfo.logln('try to delete temp node');
                Property.getNode('/scripts/led-wizard').removeChild('temp');
            }
            //
            //lInfo.logln("Eventparameter " + JSON.stringify(oIDObject));
            supplierID=getSupplierID(raisedEvent.parameter.curve_id);
            lInfo.logln("supplier id " +supplierID);
            
            if (raisedEvent.parameter.curve_id<0) {
            	new Event('led-wizard.prog',{actions:'programmCurveValues',dsuid:raisedEvent.parameter.dsuid,curveValue:raisedEvent.parameter.curve_id}).raise();
            } else {                       
	            if (Property.getNode('/scripts/led-wizard.manufacture-' + supplierID + 
	            		                 '/myData/illuminant' + raisedEvent.parameter.curve_id + '/curves')!=null) {  
	            	lInfo.logln('Curves already loaded, so execute it directly')
	            	var sCurve=Property.getProperty('/scripts/led-wizard.manufacture-' + supplierID + 
			                 '/myData/illuminant' + raisedEvent.parameter.curve_id + '/curves')
	            	
	            	sCurve = sCurve.replace(/&amp;/g, '&').replace(/&quot;/g, '"').replace(/&lt;/g, '<').replace(/&gt;/g, '>').replace(/&#039;/g, '\'');
	            	
	            	var dataString=Property.getProperty('/scripts/led-wizard.manufacture-' + supplierID + 
			                 '/myData/illuminant' + raisedEvent.parameter.curve_id + '/data');
	            	var dimmMin=null;
	            	var dimmType=null;
	            	if (dataString!=null) {
	            		var oObject=JSON.parse(dataString);
	            		dimmMin=oObject.dimmMin;
	            		dimmType=oObject.dimmType;
	            	} else {
	            		throw ('datastring is null');
	            	}
	            	
	            	new Event('led-wizard.prog',{actions:'programmCurveValues',dsuid:raisedEvent.parameter.dsuid,curveValue:sCurve,dimmMin:dimmMin,dimmType:dimmType}).raise();
	            	
	            } else if (Property.getNode('/scripts/led-wizard.manufacture-' + supplierID)!=null){
	            	lInfo.logln('Suppliers loaded, but no curves loaded');
	            	new Event('led-wizard.query-'+ supplierID,{actions:'programmCurve', curve_id:raisedEvent.parameter.curve_id,dsuid:raisedEvent.parameter.dsuid}).raise();
	            } else {
	            	if (raisedEvent.parameter.retry!=null) {
		            	lInfo.logln('Entry not found in DB, so assuming error and break the cycle');    
						new Event('led-wizard.step',{detail:'complete',error:true}).raise();
						new Event('led-wizard.answer',{type:'step',detail:'complete',error:true}).raise();
	            	} else {
		            	lInfo.logln('DB not loaded, so DB must be load before acting further');
		            	Property.setProperty('shouldProgramm/dsuid',raisedEvent.parameter.dsuid);
		            	Property.setProperty('shouldProgramm/curve_id',raisedEvent.parameter.curve_id);
		            	new Event('led-wizard.data-static',{}).raise();
	            	}
	            }
            }    
            
            //executeProgramm(oIDObject,raisedEvent.parameter.curve_id);   
            	
	    } catch (e) {lInfo.logln('catch exception during delete temp node ' + e);}
    }
	if (raisedEvent.parameter.actions == 'programmCurveValues') {
		var oIDObject=JSON.parse(unescape(raisedEvent.parameter.dsuid));
		executeProgramm(oIDObject,raisedEvent.parameter.curveValue,raisedEvent.parameter.dimmMin,raisedEvent.parameter.dimmType);  
	}
	if (raisedEvent.parameter.actions === 'deleteEntry') {
	    deleteDevice(raisedEvent.parameter.dsuid);
	}
}

	
